
#include <i86.h>
#include <dos.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include "vdt.h"
#include "global.h"
#include "cpart8.h"


//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart8::Startup() {

 picture.Create(640,237);
#ifdef datafile
 dl.Seek("pest2.pcx");
 picture.Load(dl.LibFile);
#else
 picture.Load("..\\data\\pest2.pcx");
#endif
 picpal.Load(&picture);
 picture.Remap(&picpal.pal);

 peace.Create(640,60);
#ifdef datafile
 dl.Seek("peace.pcx");
 peace.Load(dl.LibFile);
#else
 peace.Load("..\\data\\peace.pcx");
#endif
 peace.Remap(&picpal.pal);

 whois.Create(640,80);
#ifdef datafile
 dl.Seek("whois.pcx");
 whois.Load(dl.LibFile);
#else
 whois.Load("..\\data\\whois.pcx");
#endif
 whois.Remap(&picpal.pal);

 return Success;
}


//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart8::Init() {

 virtscr.Create(640,480);
 //printf("init OK\n");
 return Success;
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart8::Terminate() {

 picture.Destroy();
 peace.Destroy();
 whois.Destroy();

 return Success;
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart8::Run() {
int k;

  if (exitflag==1) return Error;
   check();

 svga.Init(mode_640x480);
 svga.Clear();
 svga.SetPalette(&picpal.pal);

 origpal.Load(&picture);

 for (k=0; k<256; k++) {
  pompal.pal[k].r=64;
  pompal.pal[k].g=64;
  pompal.pal[k].b=64;
 }


 //reset timer
 frameCount=0;
 do{
  for (k=0; k<256; k++) {
   if (pompal.pal[k].r > origpal.pal[k].r) pompal.pal[k].r--;
   if (pompal.pal[k].g > origpal.pal[k].g) pompal.pal[k].g--;
   if (pompal.pal[k].b > origpal.pal[k].b) pompal.pal[k].b--;
  }
  svga.SetPalette(&pompal.pal);
  virtscr.Copy(&picture,0,0);
  virtscr.Copy(&whois,0,250);
  virtscr.Copy(&peace,0,480-60);
  svga.Copy(&virtscr,0,0);
   //if keypress
  if (exitflag==1) return Error;
  check();
 } while (frameCount<780);

 for (k=0; k<256; k++) {
  origpal.pal[k].r=0;
  origpal.pal[k].g=0;
  origpal.pal[k].b=0;
 }

 int checkf;
 do{
  checkf=0;
  for (k=0; k<256; k++) {
   if (pompal.pal[k].r > origpal.pal[k].r) pompal.pal[k].r--,checkf=1;
   if (pompal.pal[k].g > origpal.pal[k].g) pompal.pal[k].g--,checkf=1;
   if (pompal.pal[k].b > origpal.pal[k].b) pompal.pal[k].b--,checkf=1;
  }
  svga.SetPalette(&pompal.pal);
  virtscr.Copy(&picture,0,0);
  virtscr.Copy(&whois,0,250);
  virtscr.Copy(&peace,0,480-60);
  svga.Copy(&virtscr,0,0);
  if (exitflag==1) return Error;
  check();
 } while( checkf );

 return Success;

}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart8::Done() {

 virtscr.Destroy();
 return Success;
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------


